/* 킹@\24Ԏv                     */
/* Copyright(C) 2011 Cobac.Net All Rights Reserved. */

module CLOCK24(
    input   CLK, RST,
    input   [2:0]   nBUTTON,
    output  [7:0]   LEDG,
    output  [6:0]   nHEX0, nHEX1, nHEX2, nHEX3
);

wire    CASEC, CAMIN;
wire    MODE,   SELECT, ADJUST;
wire    SECCLR, MININC, HOURINC;
wire    SECON,  MINON,  HOURON;
wire    EN1HZ,  SIG2HZ;
wire    [2:0]   btn;
wire    [3:0]   SECL, MINL, HOURL;
wire    [2:0]   SECH, MINH;
wire    [1:0]   HOURH;

/* eubN̐ڑ */
CNT1SEC CNT1SEC( .CLK(CLK), .RST(RST), .EN1HZ(EN1HZ), .SIG2HZ(SIG2HZ) );

BTN_IN  BTN_IN ( .CLK(CLK), .RST(RST), .nBIN(nBUTTON),
                 .BOUT({MODE, SELECT, ADJUST}) );

SECCNT   SEC ( .CLK(CLK), .RST(RST), .EN(EN1HZ), .CLR(SECCLR),
               .QH(SECH), .QL(SECL), .CA(CASEC) );

MINCNT   MIN ( .CLK(CLK), .RST(RST), .EN(CASEC), .INC(MININC),
               .QH(MINH), .QL(MINL), .CA(CAMIN) );

HOURCNT HOUR ( .CLK(CLK), .RST(RST), .EN(CAMIN), .INC(HOURINC),
               .QH(HOURH),.QL(HOURL) );

STATE  STATE ( .CLK(CLK), .RST(RST), .SIG2HZ(SIG2HZ),
               .MODE(MODE),     .SELECT(SELECT), .ADJUST(ADJUST),
               .SECCLR(SECCLR), .MININC(MININC), .HOURINC(HOURINC),
               .SECON(SECON),   .MINON(MINON),   .HOURON(HOURON) );

SEG7DEC ML(.DIN(MINL),           .EN(MINON),  .nHEX(nHEX0[6:0]));
SEG7DEC MH(.DIN({1'b0, MINH}),   .EN(MINON),  .nHEX(nHEX1[6:0]));
SEG7DEC HL(.DIN(HOURL),          .EN(HOURON), .nHEX(nHEX2[6:0]));
SEG7DEC HH(.DIN({2'b00, HOURH}), .EN(HOURON), .nHEX(nHEX3[6:0]));

/* b̓_Ő */
assign LEDG[3:0] = (SECON==1'b1) ? SECL: 4'h0;
assign LEDG[6:4] = (SECON==1'b1) ? SECH: 3'h0;
assign LEDG[7]   = 1'b0;

endmodule
