/* Copyright(C) 2011 Cobac.Net All rights reserved. */

module MYPIO32(
    /* AvalonoX */
    input           CLK, RST,
    input           ADDR,
    input           WRITE, READ,
    input   [3:0]   BYTEEN,
    input   [31:0]  WRDATA,
    output  [31:0]  RDDATA,
    /* |[g */
    input   [3:0]   SW,
    output reg [6:0]   nHEX0,
    output reg [6:0]   nHEX1,
    output reg [6:0]   nHEX2,
    output reg [6:0]   nHEX3
);

/* o̓WX^ */
always @( posedge CLK, posedge RST ) begin
    if ( RST )
        {nHEX3, nHEX2, nHEX1, nHEX0} <= 32'hFFFF_FFFF;
    else if ( WRITE && ADDR==1'b0 ) begin
        if ( BYTEEN[0] )
            nHEX0 <= WRDATA[6:0];
        if ( BYTEEN[1] )
            nHEX1 <= WRDATA[14:8];
        if ( BYTEEN[2] )
            nHEX2 <= WRDATA[22:16];
        if ( BYTEEN[3] )
            nHEX3 <= WRDATA[30:24];
    end
end

/* ̓WX^ */
assign RDDATA = (READ==1'b0) ? 32'h0000_0000:
                (ADDR==1'b0) ? {1'b0, nHEX3, 1'b0, nHEX2, 1'b0, nHEX1, 1'b0, nHEX0}:
                               {28'h000_0000, SW};

endmodule
